"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("react");
var useClickOutside_1 = require("../../../hooks/useClickOutside");
var ArrowButton_1 = require("../../../components/common/ArrowButton");
var useActive_1 = require("../../../hooks/useActive");
var lodash_1 = require("lodash");
var Styled = require("./style");
var event_1 = require("../../../utilities/event");
var useSetScrollPosition_1 = require("../../../hooks/useSetScrollPosition");
var props_1 = require("../../../utilities/props");
var Select = (0, react_1.forwardRef)(function (props, forwardedRef) {
    var _a, _b, _c;
    var _d = props.searchable, searchable = _d === void 0 ? false : _d, _e = props.showItemCount, showItemCount = _e === void 0 ? 8 : _e, children = props.children, value = props.value, placeholder = props.placeholder, onChange = props.onChange, _f = props.onFocus, onFocus = _f === void 0 ? function () { } : _f, _g = props.onSearch, onSearch = _g === void 0 ? function () { } : _g, listStyle = props.listStyle, itemStyle = props.itemStyle;
    var childrens = lodash_1.default.isArray(children) ? children : [children];
    var _h = (0, useActive_1.default)(), active = _h.active, setActive = _h.setActive, handleActive = _h.handleActive;
    var _j = (0, react_1.useState)(""), search = _j[0], setSearch = _j[1];
    var _k = (0, react_1.useState)(childrens), result = _k[0], setResult = _k[1];
    var containerRef = (0, react_1.useRef)(null);
    var listRef = (0, react_1.useRef)(null);
    var itemRef = (0, react_1.useRef)(null);
    var itemIndex = result.findIndex(function (item) { return item.props.value === value; });
    var itemHeight = (_b = (_a = itemRef.current) === null || _a === void 0 ? void 0 : _a.clientHeight) !== null && _b !== void 0 ? _b : 0;
    (0, useClickOutside_1.default)(containerRef, setActive);
    (0, useSetScrollPosition_1.default)(listRef, itemIndex * itemHeight, active);
    (0, react_1.useEffect)(function () {
        if (active) {
            setResult(childrens);
        }
    }, [active]);
    var handleKeyDown = (0, react_1.useCallback)(function (e) {
        switch (e.nativeEvent.key) {
            case "Enter":
                var find = childrens.find(function (item) { return (item === null || item === void 0 ? void 0 : item.props.children) === search; });
                find && handleDispatchChange(find.props);
                break;
            case "Escape":
                setActive(false);
                break;
            default:
                var filter = childrens.filter(function (item) {
                    return item === null || item === void 0 ? void 0 : item.props.children.includes(search);
                });
                setResult(filter);
                setActive(true);
        }
    }, [search]);
    var handleSearch = (0, react_1.useCallback)(function (e) {
        setSearch(e.target.value);
        onSearch(e);
    }, []);
    var handleFocus = (0, react_1.useCallback)(function (e) {
        setActive(true);
        onFocus(e);
    }, []);
    var handleDispatchChange = (0, react_1.useCallback)(function (props) {
        (0, event_1.dispatchChange)(containerRef, props.value);
        setSearch(props.children);
        setActive(false);
    }, []);
    return ((0, jsx_runtime_1.jsxs)(Styled.Container, __assign({ ref: containerRef, active: active, style: (0, props_1.getStyleProps)(props) }, { children: [(0, jsx_runtime_1.jsx)("input", { ref: forwardedRef, value: value, onChange: onChange, readOnly: true, hidden: true }), (0, jsx_runtime_1.jsx)(Styled.Input, { value: searchable ? search : value, placeholder: placeholder, onChange: handleSearch, onFocus: handleFocus, onKeyUp: function (e) { return handleKeyDown(e); }, readOnly: searchable ? false : true }), (0, jsx_runtime_1.jsx)(ArrowButton_1.default, { onClick: handleActive, direction: active ? "Up" : "Down" }), (0, jsx_runtime_1.jsx)(Styled.List, __assign({ ref: listRef, active: active, itemHeight: (_c = itemStyle === null || itemStyle === void 0 ? void 0 : itemStyle.height) !== null && _c !== void 0 ? _c : "35px", showItemCount: Math.min(childrens.length, showItemCount), style: listStyle }, { children: result.map(function (item) { return ((0, jsx_runtime_1.jsx)(Styled.Item, __assign({ ref: itemRef, active: item.props.value === value, onClick: function () { return handleDispatchChange(item.props); }, style: itemStyle }, { children: item.props.children }), item.props.value)); }) }))] })));
});
exports.default = Select;
