"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var Styled = require("./style");
var react_1 = require("react");
var time_1 = require("../../../types/time");
var useClickOutside_1 = require("../../../hooks/useClickOutside");
var useSetScrollPosition_1 = require("../../../hooks/useSetScrollPosition");
var TimeType_1 = require("./TimeType");
var Hour_1 = require("./Hour");
var Min_1 = require("./Min");
var Seconds_1 = require("./Seconds");
var ArrowButton_1 = require("../../common/ArrowButton");
var useActive_1 = require("../../../hooks/useActive");
var event_1 = require("../../../utilities/event");
var string_1 = require("../../../utilities/string");
var lodash_1 = require("lodash");
var useCursor_1 = require("../../../hooks/useCursor");
var props_1 = require("../../../utilities/props");
var TimePicker = (0, react_1.forwardRef)(function (props, forwardedRef) {
    var _a, _b, _c;
    var _d = props.show24Hour, show24Hour = _d === void 0 ? false : _d, _e = props.showSeconds, showSeconds = _e === void 0 ? false : _e, _f = props.showItemCount, showItemCount = _f === void 0 ? 8 : _f, value = props.value, onChange = props.onChange, _g = props.onFocus, onFocus = _g === void 0 ? function () { } : _g, _h = props.onSearch, onSearch = _h === void 0 ? function () { } : _h, listStyle = props.listStyle, itemStyle = props.itemStyle;
    var _j = (0, useActive_1.default)(), active = _j.active, setActive = _j.setActive, handleActive = _j.handleActive;
    var _k = (0, react_1.useState)(time_1.Time.string("" + value)), time = _k[0], setTime = _k[1];
    var _l = (0, react_1.useState)(time.getTimesOfDay()), timesOfDay = _l[0], setTimesOfDay = _l[1];
    var _m = (0, react_1.useState)(time.getHour() % 12), hour = _m[0], setHour = _m[1];
    var _o = (0, react_1.useState)(time.getMin()), min = _o[0], setMin = _o[1];
    var _p = (0, react_1.useState)(time.getSeconds()), seconds = _p[0], setSeconds = _p[1];
    var containerRef = (0, react_1.useRef)(null);
    var inputRef = (0, react_1.useRef)(null);
    var hourRef = (0, react_1.useRef)(null);
    var minRef = (0, react_1.useRef)(null);
    var secondsRef = (0, react_1.useRef)(null);
    var setCursor = (0, useCursor_1.default)(inputRef, time).setCursor;
    var itemHeight = (_b = (_a = containerRef.current) === null || _a === void 0 ? void 0 : _a.getElementsByTagName("li")[0].clientHeight) !== null && _b !== void 0 ? _b : 0;
    (0, useClickOutside_1.default)(containerRef, setActive);
    (0, useSetScrollPosition_1.default)(hourRef, hour * itemHeight, active);
    (0, useSetScrollPosition_1.default)(minRef, min * itemHeight, active);
    (0, useSetScrollPosition_1.default)(secondsRef, seconds * itemHeight, active);
    (0, react_1.useEffect)(function () {
        handleDispatchChange(time.getString({ show24Hour: true, showSeconds: showSeconds }));
        setTimesOfDay(time.getTimesOfDay());
        setHour(time.getHour() % 12);
        setMin(time.getMin());
        setSeconds(time.getSeconds());
    }, [time]);
    /**
     * Click handler
     */
    var handleClick = (0, react_1.useCallback)(function (e, value, type) {
        var newTime = lodash_1.default.cloneDeep(time);
        switch (type) {
            case time_1.UNIT.TIMES_OF_DAY:
                newTime.setHour(hour, value ? time_1.TIMES_OF_DAY.PM : time_1.TIMES_OF_DAY.AM);
                break;
            case time_1.UNIT.HOUR:
                newTime.setHour(value, time.getTimesOfDay());
                break;
            case time_1.UNIT.MIN:
                newTime.setMin(value);
                break;
            case time_1.UNIT.SECONDS:
                newTime.setSeconds(value);
                break;
        }
        setTime(newTime);
    }, [time, hour]);
    /**
     * Change Handler
     */
    var handleChange = (0, react_1.useCallback)(function (e) {
        var event = e.nativeEvent;
        var target = e.target;
        var cursor = target === null || target === void 0 ? void 0 : target.selectionStart;
        if (!cursor || !event.data)
            return;
        var data = event.data.toUpperCase();
        setCursor(cursor);
        // in show24Hour, only numbers are allowed
        if (show24Hour && isNaN(+data))
            return;
        // in show12Hour, optionally allowed
        if (!show24Hour) {
            if (cursor === 1 && !(data === "A" || data === "P"))
                return;
            if (cursor === 2 && data !== "M")
                return;
            if (3 <= cursor && isNaN(+data))
                return;
        }
        // cursor positioned char is colon or space, replaced
        if (target.value.charAt(cursor) === ":" ||
            target.value.charAt(cursor) === " ") {
            target.value = (0, string_1.replaceAt)(target.value, cursor - 1, "");
            target.value = (0, string_1.replaceAt)(target.value, cursor, data);
            setCursor(cursor + 1);
        }
        else {
            target.value = (0, string_1.replaceAt)(target.value, cursor, "");
            setCursor(cursor);
        }
        setTime(time_1.Time.string(target.value));
        onSearch(e);
    }, [show24Hour]);
    /**
     * Focus handler
     */
    var handleFocus = (0, react_1.useCallback)(function (e) {
        setActive(true);
        onFocus(e);
    }, []);
    /**
     * Dispatch change
     */
    var handleDispatchChange = (0, react_1.useCallback)(function (value) {
        (0, event_1.dispatchChange)(containerRef, value);
    }, []);
    var style = __assign({}, props.style);
    return ((0, jsx_runtime_1.jsxs)(Styled.Container, __assign({ ref: containerRef, active: active, style: (0, props_1.getStyleProps)(props) }, { children: [(0, jsx_runtime_1.jsx)("input", { ref: forwardedRef, value: value, onChange: onChange, readOnly: true, hidden: true }), (0, jsx_runtime_1.jsx)(Styled.Input, { ref: inputRef, value: time.getString({ show24Hour: show24Hour, showSeconds: showSeconds }), onChange: handleChange, onFocus: handleFocus }), (0, jsx_runtime_1.jsx)(ArrowButton_1.default, { onClick: handleActive, direction: active ? "Up" : "Down" }), (0, jsx_runtime_1.jsxs)(Styled.ListContainer, __assign({ active: active, itemHeight: (_c = itemStyle === null || itemStyle === void 0 ? void 0 : itemStyle.height) !== null && _c !== void 0 ? _c : "35px", showItemCount: showItemCount, style: listStyle }, { children: [(0, jsx_runtime_1.jsx)(TimeType_1.default, { timeType: timesOfDay, onClick: handleClick, itemStyle: itemStyle }), (0, jsx_runtime_1.jsx)(Hour_1.default, { hourRef: hourRef, hour: hour, onClick: handleClick, itemStyle: itemStyle }), (0, jsx_runtime_1.jsx)(Min_1.default, { minRef: minRef, min: min, onClick: handleClick, itemStyle: itemStyle }), showSeconds && ((0, jsx_runtime_1.jsx)(Seconds_1.default, { secondsRef: secondsRef, seconds: seconds, onClick: handleClick, itemStyle: itemStyle }))] }))] })));
});
exports.default = TimePicker;
