"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("react");
var Styled = require("./style");
var props_1 = require("../../../utilities/props");
var DIRECTIONS = {
    horizontal: "horizontal",
    vertical: "vertical",
};
/**
 * Divider Component
 */
var Divider = (0, react_1.forwardRef)(function (props, forwardedRef) {
    var _a, _b, _c, _d, _e, _f, _g;
    var direction = props.direction, label = props.label, labelStyle = props.labelStyle;
    var labelRef = (0, react_1.useRef)(null);
    var border = direction === "horizontal"
        ? {
            borderTopStyle: (_a = props.borderStyle) !== null && _a !== void 0 ? _a : "solid",
            borderTopColor: (_b = props.borderColor) !== null && _b !== void 0 ? _b : "gray",
            borderTopWidth: (_c = props.borderWidth) !== null && _c !== void 0 ? _c : "1px",
        }
        : {
            borderRightStyle: (_d = props.borderStyle) !== null && _d !== void 0 ? _d : "solid",
            borderRightColor: (_e = props.borderColor) !== null && _e !== void 0 ? _e : "gray",
            borderRightWidth: (_f = props.borderWidth) !== null && _f !== void 0 ? _f : "1px",
        };
    var style = __assign(__assign({ width: direction === "horizontal" ? "100%" : props.borderWidth, height: props.direction === "horizontal" ? "initial" : "100%" }, border), props.style);
    return ((0, jsx_runtime_1.jsxs)(Styled.Container, __assign({ height: (_g = labelRef.current) === null || _g === void 0 ? void 0 : _g.clientHeight, style: (0, props_1.getStyleProps)(props) }, { children: [(0, jsx_runtime_1.jsx)("div", __assign({}, props, { ref: forwardedRef, style: style })), (0, jsx_runtime_1.jsx)(Styled.Label, __assign({ ref: labelRef, style: labelStyle }, { children: label }))] })));
});
exports.default = Divider;
