"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var useThrottle = function (callback, timeout) {
    var ready = (0, react_1.useRef)(true);
    var timerRef = (0, react_1.useRef)();
    return function () {
        var params = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            params[_i] = arguments[_i];
        }
        if (ready.current) {
            clearTimeout(timerRef.current);
            callback.apply(void 0, params); // 콜백을 실행하고
            ready.current = false; // ready 상태를 false로 바꿈
            timerRef.current = setTimeout(function () {
                ready.current = true; // 대기 시간이 지나면 ready 상태를 true로 바꿈
            }, timeout);
        }
    };
};
exports.default = useThrottle;
