"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ALL_ABBR_PROPS = exports.COMMON_ABBR_PROPS = exports.EFFECT_ABBR_PROPS = exports.BORDER_ABBR_PROPS = exports.BACKGROUND_ABBR_PROPS = exports.LIST_ABBR_PROPS = exports.FONT_ABBR_PROPS = exports.SIZING_ABBR_PROPS = exports.SPACING_ABBR_PROPS = exports.GRID_ABBR_PROPS = exports.FLEX_ABBR_PROPS = exports.FLEX_GRID_ABBR_PROPS = exports.LAYOUT_ABBR_PROPS = void 0;
// /**
//  * Generic Type of Abbreviation PropTypes
//  */
// export type AbbrProperties<T> = {
//   [key in keyOf<T>]?: AllProperties[T[key]];
// };
/**
 * Abbreviation Style Property Types of Layout
 */
exports.LAYOUT_ABBR_PROPS = {
    d: "display",
    of: "overflow",
    ps: "position",
    v: "visibility",
    z: "zIndex",
};
/**
 * Abbreviation Style Property Types of Flex & Grid
 */
exports.FLEX_GRID_ABBR_PROPS = {
    ai: "alignItems",
    jc: "justifyContent",
    rg: "rowGap",
    cg: "columnGap",
};
/**
 * Abbreviation Style Property Types of Flex
 */
exports.FLEX_ABBR_PROPS = {
    fd: "flexDirection",
    ac: "alignContent",
    fw: "flexWrap",
};
/**
 * Abbreviation Style Property Types of Grid
 */
exports.GRID_ABBR_PROPS = {
    gac: "gridAutoColumns",
    gar: "gridAutoRows",
    gaf: "gridAutoFlow",
    gtc: "gridTemplateColumns",
    gtr: "gridTemplateRows",
    gta: "gridTemplateAreas",
};
/**
 * Abbreviation Style Property Types of Spacing
 */
exports.SPACING_ABBR_PROPS = {
    m: "margin",
    mt: "marginTop",
    mr: "marginRight",
    mb: "marginBottom",
    ml: "marginLeft",
    p: "padding",
    pt: "paddingTop",
    pr: "paddingRight",
    pb: "paddingBottom",
    pl: "paddingLeft",
};
/**
 * Abbreviation Style Property Types of Sizing
 */
exports.SIZING_ABBR_PROPS = {
    w: "width",
    minW: "minWidth",
    maxW: "maxWidth",
    h: "height",
    minH: "minHeight",
    maxH: "maxHeight",
};
/**
 * Abbreviation Style Property Types of Font
 */
exports.FONT_ABBR_PROPS = {
    c: "color",
    f: "font",
    fst: "fontStyle",
    fw: "fontWeight",
    fs: "fontSize",
    ff: "fontFamily",
    fv: "fontVariant",
    lh: "lineHeight",
    ta: "textAlign",
    tof: "textOverflow",
    td: "textDecoration",
    ws: "whiteSpace",
};
/**
 * Abbreviation Style Property Types of List
 */
exports.LIST_ABBR_PROPS = {
    ls: "listStyle",
    lst: "listStyleType",
    lsp: "listStylePosition",
};
/**
 * Abbreviation Style Property Types of Background
 */
exports.BACKGROUND_ABBR_PROPS = {
    bg: "background",
    bgc: "backgroundColor",
};
/**
 * Abbreviation Style Property Types of Border
 */
exports.BORDER_ABBR_PROPS = {
    b: "border",
    bt: "borderTop",
    br: "borderRight",
    bb: "borderBottom",
    bl: "borderLeft",
    o: "outline",
    radius: "borderRadius",
};
/**
 * Abbreviation Style Property Types of Effects
 */
exports.EFFECT_ABBR_PROPS = {
    bs: "boxShadow",
};
/**
 * Common Abbreviation Style Property Types
 */
exports.COMMON_ABBR_PROPS = __assign(__assign(__assign(__assign(__assign(__assign(__assign({}, exports.LAYOUT_ABBR_PROPS), exports.SPACING_ABBR_PROPS), exports.SIZING_ABBR_PROPS), exports.FONT_ABBR_PROPS), exports.BACKGROUND_ABBR_PROPS), exports.BORDER_ABBR_PROPS), exports.EFFECT_ABBR_PROPS);
/**
 * All Abbreviation Style Property Types
 */
exports.ALL_ABBR_PROPS = __assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign({}, exports.LAYOUT_ABBR_PROPS), exports.FLEX_GRID_ABBR_PROPS), exports.FLEX_ABBR_PROPS), exports.GRID_ABBR_PROPS), exports.SPACING_ABBR_PROPS), exports.SIZING_ABBR_PROPS), exports.FONT_ABBR_PROPS), exports.LIST_ABBR_PROPS), exports.BACKGROUND_ABBR_PROPS), exports.BORDER_ABBR_PROPS), exports.EFFECT_ABBR_PROPS);
