var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import * as Styled from "./style";
import { forwardRef, useCallback, useEffect, useRef, useState, } from "react";
import { Time, TIMES_OF_DAY, UNIT } from "../../../types/time";
import useClickOutside from "../../../hooks/useClickOutside";
import useSetScrollPosition from "../../../hooks/useSetScrollPosition";
import TimeType from "./TimeType";
import Hour from "./Hour";
import Min from "./Min";
import Seconds from "./Seconds";
import ArrowButton from "../../common/ArrowButton";
import useActive from "../../../hooks/useActive";
import { dispatchChange } from "../../../utilities/event";
import { replaceAt } from "../../../utilities/string";
import _ from "lodash";
import useCursor from "../../../hooks/useCursor";
import { getStyleProps } from "../../../utilities/props";
var TimePicker = forwardRef(function (props, forwardedRef) {
    var _a, _b, _c;
    var _d = props.show24Hour, show24Hour = _d === void 0 ? false : _d, _e = props.showSeconds, showSeconds = _e === void 0 ? false : _e, _f = props.showItemCount, showItemCount = _f === void 0 ? 8 : _f, value = props.value, onChange = props.onChange, _g = props.onFocus, onFocus = _g === void 0 ? function () { } : _g, _h = props.onSearch, onSearch = _h === void 0 ? function () { } : _h, listStyle = props.listStyle, itemStyle = props.itemStyle;
    var _j = useActive(), active = _j.active, setActive = _j.setActive, handleActive = _j.handleActive;
    var _k = useState(Time.string("" + value)), time = _k[0], setTime = _k[1];
    var _l = useState(time.getTimesOfDay()), timesOfDay = _l[0], setTimesOfDay = _l[1];
    var _m = useState(time.getHour() % 12), hour = _m[0], setHour = _m[1];
    var _o = useState(time.getMin()), min = _o[0], setMin = _o[1];
    var _p = useState(time.getSeconds()), seconds = _p[0], setSeconds = _p[1];
    var containerRef = useRef(null);
    var inputRef = useRef(null);
    var hourRef = useRef(null);
    var minRef = useRef(null);
    var secondsRef = useRef(null);
    var setCursor = useCursor(inputRef, time).setCursor;
    var itemHeight = (_b = (_a = containerRef.current) === null || _a === void 0 ? void 0 : _a.getElementsByTagName("li")[0].clientHeight) !== null && _b !== void 0 ? _b : 0;
    useClickOutside(containerRef, setActive);
    useSetScrollPosition(hourRef, hour * itemHeight, active);
    useSetScrollPosition(minRef, min * itemHeight, active);
    useSetScrollPosition(secondsRef, seconds * itemHeight, active);
    useEffect(function () {
        handleDispatchChange(time.getString({ show24Hour: true, showSeconds: showSeconds }));
        setTimesOfDay(time.getTimesOfDay());
        setHour(time.getHour() % 12);
        setMin(time.getMin());
        setSeconds(time.getSeconds());
    }, [time]);
    /**
     * Click handler
     */
    var handleClick = useCallback(function (e, value, type) {
        var newTime = _.cloneDeep(time);
        switch (type) {
            case UNIT.TIMES_OF_DAY:
                newTime.setHour(hour, value ? TIMES_OF_DAY.PM : TIMES_OF_DAY.AM);
                break;
            case UNIT.HOUR:
                newTime.setHour(value, time.getTimesOfDay());
                break;
            case UNIT.MIN:
                newTime.setMin(value);
                break;
            case UNIT.SECONDS:
                newTime.setSeconds(value);
                break;
        }
        setTime(newTime);
    }, [time, hour]);
    /**
     * Change Handler
     */
    var handleChange = useCallback(function (e) {
        var event = e.nativeEvent;
        var target = e.target;
        var cursor = target === null || target === void 0 ? void 0 : target.selectionStart;
        if (!cursor || !event.data)
            return;
        var data = event.data.toUpperCase();
        setCursor(cursor);
        // in show24Hour, only numbers are allowed
        if (show24Hour && isNaN(+data))
            return;
        // in show12Hour, optionally allowed
        if (!show24Hour) {
            if (cursor === 1 && !(data === "A" || data === "P"))
                return;
            if (cursor === 2 && data !== "M")
                return;
            if (3 <= cursor && isNaN(+data))
                return;
        }
        // cursor positioned char is colon or space, replaced
        if (target.value.charAt(cursor) === ":" ||
            target.value.charAt(cursor) === " ") {
            target.value = replaceAt(target.value, cursor - 1, "");
            target.value = replaceAt(target.value, cursor, data);
            setCursor(cursor + 1);
        }
        else {
            target.value = replaceAt(target.value, cursor, "");
            setCursor(cursor);
        }
        setTime(Time.string(target.value));
        onSearch(e);
    }, [show24Hour]);
    /**
     * Focus handler
     */
    var handleFocus = useCallback(function (e) {
        setActive(true);
        onFocus(e);
    }, []);
    /**
     * Dispatch change
     */
    var handleDispatchChange = useCallback(function (value) {
        dispatchChange(containerRef, value);
    }, []);
    var style = __assign({}, props.style);
    return (_jsxs(Styled.Container, __assign({ ref: containerRef, active: active, style: getStyleProps(props) }, { children: [_jsx("input", { ref: forwardedRef, value: value, onChange: onChange, readOnly: true, hidden: true }), _jsx(Styled.Input, { ref: inputRef, value: time.getString({ show24Hour: show24Hour, showSeconds: showSeconds }), onChange: handleChange, onFocus: handleFocus }), _jsx(ArrowButton, { onClick: handleActive, direction: active ? "Up" : "Down" }), _jsxs(Styled.ListContainer, __assign({ active: active, itemHeight: (_c = itemStyle === null || itemStyle === void 0 ? void 0 : itemStyle.height) !== null && _c !== void 0 ? _c : "35px", showItemCount: showItemCount, style: listStyle }, { children: [_jsx(TimeType, { timeType: timesOfDay, onClick: handleClick, itemStyle: itemStyle }), _jsx(Hour, { hourRef: hourRef, hour: hour, onClick: handleClick, itemStyle: itemStyle }), _jsx(Min, { minRef: minRef, min: min, onClick: handleClick, itemStyle: itemStyle }), showSeconds && (_jsx(Seconds, { secondsRef: secondsRef, seconds: seconds, onClick: handleClick, itemStyle: itemStyle }))] }))] })));
});
export default TimePicker;
